Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 2231)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 2232)
@@ -857,25 +1087,7 @@
 !--       case in the user interface. There, the subroutine user_init_grid 
 !--       checks which of these two conditions applies.
-          CALL user_init_grid( nzb_local )
+          CALL user_init_grid( topo_3d )
 
     END SELECT
-!
-!-- Determine the maximum level of topography. Furthermore it is used for
-!-- steering the degradation of order of the applied advection scheme.
-!-- In case of non-cyclic lateral boundaries, the order of the advection
-!-- scheme has to be reduced up to nzt (required at the lateral boundaries).
-#if defined( __parallel )
-    CALL MPI_ALLREDUCE( MAXVAL( nzb_local ) + 1, nzb_max, 1, MPI_INTEGER,      &
-                        MPI_MAX, comm2d, ierr )
-#else
-    nzb_max = MAXVAL( nzb_local ) + 1
-#endif
-    IF ( inflow_l .OR. outflow_l .OR. inflow_r .OR. outflow_r .OR.             &
-         inflow_n .OR. outflow_n .OR. inflow_s .OR. outflow_s .OR.             &
-         nest_domain )                                                         &
-    THEN
-       nzb_max = nzt
-    ENDIF
-
 !
 !-- Consistency checks and index array initialization are only required for
@@ -901,4 +1113,41 @@
                                 '&MAXVAL( nzb_local ) = ', nzb_local_max
           CALL message( 'init_grid', 'PA0210', 1, 2, 0, 6, 0 )
+       ENDIF
+!
+!--    In case of non-flat topography, check whether the convention how to 
+!--    define the topography grid has been set correctly, or whether the default
+!--    is applicable. If this is not possible, abort.
+       IF ( TRIM( topography_grid_convention ) == ' ' )  THEN
+          IF ( TRIM( topography ) /= 'single_building' .AND.                   &
+               TRIM( topography ) /= 'single_street_canyon' .AND.              &
+               TRIM( topography ) /= 'tunnel'  .AND.                           &
+               TRIM( topography ) /= 'read_from_file')  THEN
+!--          The default value is not applicable here, because it is only valid
+!--          for the two standard cases 'single_building' and 'read_from_file'
+!--          defined in init_grid.
+             WRITE( message_string, * )                                        &
+                  'The value for "topography_grid_convention" ',               &
+                  'is not set. Its default value is & only valid for ',        &
+                  '"topography" = ''single_building'', ',                      &
+                  '''single_street_canyon'' & or ''read_from_file''.',         &
+                  ' & Choose ''cell_edge'' or ''cell_center''.'
+             CALL message( 'init_grid', 'PA0239', 1, 2, 0, 6, 0 )
+          ELSE
+!--          The default value is applicable here.
+!--          Set convention according to topography.
+             IF ( TRIM( topography ) == 'single_building' .OR.                 &
+                  TRIM( topography ) == 'single_street_canyon' )  THEN
+                topography_grid_convention = 'cell_edge'
+             ELSEIF ( TRIM( topography ) == 'read_from_file'  .OR.             &
+                      TRIM( topography ) == 'tunnel')  THEN
+                topography_grid_convention = 'cell_center'
+             ENDIF
+          ENDIF
+       ELSEIF ( TRIM( topography_grid_convention ) /= 'cell_edge' .AND.        &
+                TRIM( topography_grid_convention ) /= 'cell_center' )  THEN
+          WRITE( message_string, * )                                           &
+               'The value for "topography_grid_convention" is ',               &
+               'not recognized. & Choose ''cell_edge'' or ''cell_center''.'
+          CALL message( 'init_grid', 'PA0240', 1, 2, 0, 6, 0 )
        ENDIF
 
@@ -964,11 +1213,38 @@
                 nzb_local(j,i) = MIN( nzb_local(j,i), nzb_local(j+1,i) )
              ENDDO
-          ENDDO
+          ENDDO  
 !
 !--       Exchange ghost points          
           CALL exchange_horiz_2d_int( nzb_local, nys, nyn, nxl, nxr, nbgp )
+!
+!--       Apply cell-edge convention also for 3D topo array. The former setting
+!--       of nzb_local will be removed later. 
+          DO  j = nys+1, nyn+1
+             DO  i = nxl-1, nxr
+                DO  k = nzb, nzt+1
+                   IF ( BTEST( topo_3d(k,j,i), 0 )  .OR.                       &
+                        BTEST( topo_3d(k,j,i+1), 0 ) )                         &
+                      topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 0 )
+                ENDDO
+             ENDDO
+          ENDDO      
+          CALL exchange_horiz_int( topo_3d, nbgp )   
+
+          DO  i = nxl, nxr+1
+             DO  j = nys-1, nyn
+                DO  k = nzb, nzt+1
+                   IF ( BTEST( topo_3d(k,j,i), 0 )  .OR.                       &
+                        BTEST( topo_3d(k,j+1,i), 0 ) )                         &
+                      topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 0 )
+                ENDDO
+             ENDDO
+          ENDDO  
+          CALL exchange_horiz_int( topo_3d, nbgp )
+   
        ENDIF
+      
 !
 !--    Initialize index arrays nzb_s_inner and nzb_w_inner
+
        nzb_s_inner = nzb_local
        nzb_w_inner = nzb_local
@@ -1103,62 +1379,4 @@
        CALL exchange_horiz_2d_int( nzb_s_outer, nys, nyn, nxl, nxr, nbgp )
 
-!
-!--    Allocate and set the arrays containing the topography height
-       ALLOCATE( zu_s_inner(0:nx+1,0:ny+1), zw_w_inner(0:nx+1,0:ny+1),         &
-                 zu_s_inner_l(0:nx+1,0:ny+1), zw_w_inner_l(0:nx+1,0:ny+1) )
-                 
-       zu_s_inner   = 0.0_wp
-       zw_w_inner   = 0.0_wp
-       zu_s_inner_l = 0.0_wp
-       zw_w_inner_l = 0.0_wp
-       
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             zu_s_inner_l(i,j) = zu(nzb_local(j,i))
-             zw_w_inner_l(i,j) = zw(nzb_local(j,i))
-          ENDDO
-       ENDDO
-       
-#if defined( __parallel )
-       CALL MPI_REDUCE( zu_s_inner_l, zu_s_inner, (nx+2)*(ny+2),         &
-                           MPI_REAL, MPI_SUM, 0, comm2d, ierr )       
-       CALL MPI_REDUCE( zw_w_inner_l, zw_w_inner, (nx+2)*(ny+2),         &
-                           MPI_REAL, MPI_SUM, 0, comm2d, ierr )  
-#else
-       zu_s_inner = zu_s_inner_l
-       zw_w_inner = zw_w_inner_l
-#endif
-
-      DEALLOCATE( zu_s_inner_l, zw_w_inner_l )
-      IF ( myid /= 0 )  DEALLOCATE( zu_s_inner, zw_w_inner )
-!
-!--   Set south and left ghost points, required for netcdf output
-      IF ( myid == 0 )  THEN
-         IF( bc_lr_cyc )  THEN
-            zu_s_inner(nx+1,:) = zu_s_inner(0,:)
-            zw_w_inner(nx+1,:) = zw_w_inner(0,:)
-         ELSE
-            zu_s_inner(nx+1,:) = zu_s_inner(nx,:)
-            zw_w_inner(nx+1,:) = zw_w_inner(nx,:)
-         ENDIF
-         IF( bc_ns_cyc )  THEN
-            zu_s_inner(:,ny+1) = zu_s_inner(:,0)
-            zw_w_inner(:,ny+1) = zw_w_inner(:,0)
-         ELSE
-            zu_s_inner(:,ny+1) = zu_s_inner(:,ny)
-            zw_w_inner(:,ny+1) = zw_w_inner(:,ny)
-         ENDIF
-      ENDIF
-!
-!--    Set flag arrays to be used for masking of grid points
-       DO  i = nxlg, nxrg
-          DO  j = nysg, nyng
-             DO  k = nzb, nzt+1
-                IF ( k <= nzb_s_inner(j,i) )  rflags_s_inner(k,j,i) = 0.0_wp
-                IF ( k <= nzb_s_inner(j,i) )  rflags_invers(j,i,k)  = 0.0_wp
-             ENDDO
-          ENDDO
-       ENDDO
-
     ENDIF
 !
@@ -1166,4 +1384,34 @@
 !-- grid-levels further below.
     DEALLOCATE( nzb_tmp )
+
+!
+!-- Determine the maximum level of topography. It is used for
+!-- steering the degradation of order of the applied advection scheme.
+!-- In case of non-cyclic lateral boundaries, the order of the advection
+!-- scheme has to be reduced up to nzt (required at the lateral boundaries).
+    k_top = 0
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb, nzt + 1
+             k_top = MAX( k_top, MERGE( k, 0,                                  &
+                                        .NOT. BTEST( topo_3d(k,j,i), 0 ) ) )
+          ENDDO
+       ENDDO
+    ENDDO
+#if defined( __parallel )
+    CALL MPI_ALLREDUCE( k_top + 1, nzb_max, 1, MPI_INTEGER,                    & !is +1 really necessary here?
+                        MPI_MAX, comm2d, ierr )
+#else
+    nzb_max = k_top + 1
+#endif
+    IF ( inflow_l .OR. outflow_l .OR. inflow_r .OR. outflow_r .OR.             &
+         inflow_n .OR. outflow_n .OR. inflow_s .OR. outflow_s .OR.             &
+         nest_domain )                                                         &
+    THEN
+       nzb_max = nzt
+    ENDIF
+!
+!-- Finally, if topography extents up to the model top, limit nzb_max to nzt.
+    nzb_max = MIN( nzb_max, nzt ) 
 
 !
@@ -1172,11 +1420,7 @@
 !-- applied 
     IF ( constant_flux_layer  .OR.  use_surface_fluxes )  THEN
-       nzb_diff_u         = nzb_u_inner + 2
-       nzb_diff_v         = nzb_v_inner + 2
        nzb_diff_s_inner   = nzb_s_inner + 2
        nzb_diff_s_outer   = nzb_s_outer + 2
     ELSE
-       nzb_diff_u         = nzb_u_inner + 1
-       nzb_diff_v         = nzb_v_inner + 1
        nzb_diff_s_inner   = nzb_s_inner + 1
        nzb_diff_s_outer   = nzb_s_outer + 1
@@ -1184,108 +1428,289 @@
 
 !
-!-- Calculation of wall switches and factors required by diffusion_u/v.f90 and 
-!-- for limitation of near-wall mixing length l_wall further below
-    corner_nl = 0
-    corner_nr = 0
-    corner_sl = 0
-    corner_sr = 0
-    wall_l    = 0
-    wall_n    = 0
-    wall_r    = 0
-    wall_s    = 0
-
-    DO  i = nxl, nxr
-       DO  j = nys, nyn
-!
-!--       u-component
-          IF ( nzb_u_outer(j,i) > nzb_u_outer(j+1,i) )  THEN
-             wall_u(j,i) = 1.0_wp   ! north wall (location of adjacent fluid)
-             fym(j,i)    = 0.0_wp
-             fyp(j,i)    = 1.0_wp
-          ELSEIF ( nzb_u_outer(j,i) > nzb_u_outer(j-1,i) )  THEN
-             wall_u(j,i) = 1.0_wp   ! south wall (location of adjacent fluid)
-             fym(j,i)    = 1.0_wp
-             fyp(j,i)    = 0.0_wp
-          ENDIF
-!
-!--       v-component
-          IF ( nzb_v_outer(j,i) > nzb_v_outer(j,i+1) )  THEN
-             wall_v(j,i) = 1.0_wp   ! rigth wall (location of adjacent fluid)
-             fxm(j,i)    = 0.0_wp
-             fxp(j,i)    = 1.0_wp
-          ELSEIF ( nzb_v_outer(j,i) > nzb_v_outer(j,i-1) )  THEN
-             wall_v(j,i) = 1.0_wp   ! left wall (location of adjacent fluid)
-             fxm(j,i)    = 1.0_wp
-             fxp(j,i)    = 0.0_wp
-          ENDIF
-!
-!--       w-component, also used for scalars, separate arrays for shear 
-!--       production of tke
-          IF ( nzb_w_outer(j,i) > nzb_w_outer(j+1,i) )  THEN
-             wall_e_y(j,i) =  1.0_wp   ! north wall (location of adjacent fluid)
-             wall_w_y(j,i) =  1.0_wp
-             fwym(j,i)     =  0.0_wp
-             fwyp(j,i)     =  1.0_wp
-          ELSEIF ( nzb_w_outer(j,i) > nzb_w_outer(j-1,i) )  THEN
-             wall_e_y(j,i) = -1.0_wp   ! south wall (location of adjacent fluid)
-             wall_w_y(j,i) =  1.0_wp
-             fwym(j,i)     =  1.0_wp
-             fwyp(j,i)     =  0.0_wp
-          ENDIF
-          IF ( nzb_w_outer(j,i) > nzb_w_outer(j,i+1) )  THEN
-             wall_e_x(j,i) =  1.0_wp   ! right wall (location of adjacent fluid)
-             wall_w_x(j,i) =  1.0_wp
-             fwxm(j,i)     =  0.0_wp
-             fwxp(j,i)     =  1.0_wp
-          ELSEIF ( nzb_w_outer(j,i) > nzb_w_outer(j,i-1) )  THEN
-             wall_e_x(j,i) = -1.0_wp   ! left wall (location of adjacent fluid)
-             wall_w_x(j,i) =  1.0_wp
-             fwxm(j,i)     =  1.0_wp
-             fwxp(j,i)     =  0.0_wp
-          ENDIF
-!
-!--       Wall and corner locations inside buildings for limitation of
-!--       near-wall mixing length l_wall
-          IF ( nzb_s_inner(j,i) > nzb_s_inner(j+1,i) )  THEN
-
-             wall_n(j,i) = nzb_s_inner(j+1,i) + 1            ! North wall
-
-             IF ( nzb_s_inner(j,i) > nzb_s_inner(j,i-1) )  THEN
-                corner_nl(j,i) = MAX( nzb_s_inner(j+1,i),  & ! Northleft corner
-                                      nzb_s_inner(j,i-1) ) + 1
-             ENDIF
-
-             IF ( nzb_s_inner(j,i) > nzb_s_inner(j,i+1) )  THEN
-                corner_nr(j,i) = MAX( nzb_s_inner(j+1,i),  & ! Northright corner
-                                      nzb_s_inner(j,i+1) ) + 1
-             ENDIF
-
-          ENDIF
-
-          IF ( nzb_s_inner(j,i) > nzb_s_inner(j-1,i) )  THEN
-
-             wall_s(j,i) = nzb_s_inner(j-1,i) + 1            ! South wall
-             IF ( nzb_s_inner(j,i) > nzb_s_inner(j,i-1) )  THEN
-                corner_sl(j,i) = MAX( nzb_s_inner(j-1,i),  & ! Southleft corner
-                                      nzb_s_inner(j,i-1) ) + 1
-             ENDIF
-
-             IF ( nzb_s_inner(j,i) > nzb_s_inner(j,i+1) )  THEN
-                corner_sr(j,i) = MAX( nzb_s_inner(j-1,i),  & ! Southright corner
-                                      nzb_s_inner(j,i+1) ) + 1
-             ENDIF
-
-          ENDIF
-
-          IF ( nzb_s_inner(j,i) > nzb_s_inner(j,i-1) )  THEN
-             wall_l(j,i) = nzb_s_inner(j,i-1) + 1            ! Left wall
-          ENDIF
-
-          IF ( nzb_s_inner(j,i) > nzb_s_inner(j,i+1) )  THEN
-             wall_r(j,i) = nzb_s_inner(j,i+1) + 1            ! Right wall
-          ENDIF
+!-- Set-up topography flags. First, set flags only for s, u, v and w-grid.
+!-- Further special flags will be set in following loops. 
+    wall_flags_0 = 0
+    DO  j = nys, nyn
+       DO  i = nxl, nxr
+          DO  k = nzb, nzt+1
+!
+!--          scalar grid
+             IF ( BTEST( topo_3d(k,j,i), 0 ) )                                 &
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 0 )
+!
+!--          v grid
+             IF ( BTEST( topo_3d(k,j,i),   0 )  .AND.                          &
+                  BTEST( topo_3d(k,j-1,i), 0 ) )                               &
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 2 )
+!
+!--     To do: set outer arrays on basis of topo_3d array, adjust for downward-facing walls
+!--          s grid outer array
+             IF ( k >= nzb_s_outer(j,i) )                                      &
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 24 )
+!
+!--          s grid outer array
+             IF ( k >= nzb_u_outer(j,i) )                                      &
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 26 )
+!
+!--          s grid outer array
+             IF ( k >= nzb_v_outer(j,i) )                                      &
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 27 )
+!
+!--          w grid outer array
+             IF ( k >= nzb_w_outer(j,i) )                                      &
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 28 )
+          ENDDO
+
+          DO k = nzb, nzt
+!
+!--          w grid
+             IF ( BTEST( topo_3d(k,j,i),   0 )  .AND.                          &
+                  BTEST( topo_3d(k+1,j,i), 0 ) )                               &
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 3 )
+          ENDDO
+          wall_flags_0(nzt+1,j,i) = IBSET( wall_flags_0(nzt+1,j,i), 3 )
 
        ENDDO
     ENDDO
+!
+!-- u grid. Note, reverse 
+!-- memory access is required for setting flag on u-grid
+    DO  j = nys, nyn
+       DO  i = nxl, nxr
+          DO k = nzb, nzt+1
+             IF ( BTEST( topo_3d(k,j,i),   0 )  .AND.                          &
+                  BTEST( topo_3d(k,j,i-1), 0 ) )                               &
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 1 )
+          ENDDO
+       ENDDO
+    ENDDO
+!
+!-- Set further special flags
+    DO i = nxl, nxr
+       DO j = nys, nyn
+          DO k = nzb, nzt+1
+!
+!--          scalar grid, former nzb_diff_s_inner.
+!--          Note, use this flag also to mask topography in diffusion_u and 
+!--          diffusion_v along the vertical direction. In case of 
+!--          use_surface_fluxes, fluxes are calculated via MOST, else, simple
+!--          gradient approach is applied. Please note, in case of u- and v-
+!--          diffuison, a small error is made at edges (on the east side for u,
+!--          at the north side for v), since topography on scalar grid point
+!--          is used instead of topography on u/v-grid. As number of topography grid
+!--          points on uv-grid is different than s-grid, different number of 
+!--          surface elements would be required. In order to avoid this, 
+!--          treat edges (u(k,j,i+1)) simply by a gradient approach, i.e. these
+!--          points are not masked within diffusion_u. Tests had shown that the
+!--          effect on the flow is negligible. 
+             IF ( constant_flux_layer  .OR.  use_surface_fluxes )  THEN
+                IF ( BTEST( wall_flags_0(k,j,i), 0 ) )                         &
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 8 )
+             ELSE
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 8 )
+             ENDIF
+
+          ENDDO
+!
+!--       Special flag to control vertical diffusion at model top - former 
+!--       nzt_diff
+          wall_flags_0(:,j,i) = IBSET( wall_flags_0(:,j,i), 9 )
+          IF ( use_top_fluxes )                                                &
+             wall_flags_0(nzt:nzt+1,j,i) = IBCLR( wall_flags_0(nzt:nzt+1,j,i), 9 )
+
+          DO k = nzb+1, nzt
+!
+!--          Special flag on u grid, former nzb_u_inner + 1, required   
+!--          for disturb_field and initialization. Do not disturb directly at
+!--          topography, as well as initialize u with zero one grid point outside
+!--          of topography.
+             IF ( BTEST( wall_flags_0(k-1,j,i), 1 )  .AND.                     &
+                  BTEST( wall_flags_0(k,j,i),   1 )  .AND.                     &
+                  BTEST( wall_flags_0(k+1,j,i), 1 ) )                          &
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 20 )
+!
+!--          Special flag on v grid, former nzb_v_inner + 1, required   
+!--          for disturb_field and initialization. Do not disturb directly at
+!--          topography, as well as initialize v with zero one grid point outside
+!--          of topography.
+             IF ( BTEST( wall_flags_0(k-1,j,i), 2 )  .AND.                     &
+                  BTEST( wall_flags_0(k,j,i),   2 )  .AND.                     &
+                  BTEST( wall_flags_0(k+1,j,i), 2 ) )                          &
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 21 )
+!
+!--          Special flag on scalar grid, former nzb_s_inner+1. Used for 
+!--          lpm_sgs_tke
+             IF ( BTEST( wall_flags_0(k,j,i),   0 )  .AND.                     &
+                  BTEST( wall_flags_0(k-1,j,i), 0 )  .AND.                     &
+                  BTEST( wall_flags_0(k+1,j,i), 0 ) )                          &
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 25 )
+!
+!--          Special flag on scalar grid, nzb_diff_s_outer - 1, required in 
+!--          in production_e
+             IF ( constant_flux_layer  .OR.  use_surface_fluxes )  THEN
+                IF ( BTEST( wall_flags_0(k,j,i),   24 )  .AND.                 &
+                     BTEST( wall_flags_0(k-1,j,i), 24 )  .AND.                 &
+                     BTEST( wall_flags_0(k+1,j,i), 0 ) )                       &
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 29 )
+             ELSE
+                IF ( BTEST( wall_flags_0(k,j,i), 0 ) )                         &
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 29 )
+             ENDIF
+!
+!--          Special flag on scalar grid, nzb_diff_s_outer - 1, required in 
+!--          in production_e
+             IF ( constant_flux_layer  .OR.  use_surface_fluxes )  THEN
+                IF ( BTEST( wall_flags_0(k,j,i),   0 )  .AND.                  &
+                     BTEST( wall_flags_0(k-1,j,i), 0 )  .AND.                  &
+                     BTEST( wall_flags_0(k+1,j,i), 0 ) )                       &
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 30 )
+             ELSE
+                IF ( BTEST( wall_flags_0(k,j,i), 0 ) )                         &
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 30 )
+             ENDIF
+          ENDDO
+!
+!--       Flags indicating downward facing walls
+          DO k = nzb+1, nzt
+!
+!--          Scalar grid
+             IF ( BTEST( wall_flags_0(k-1,j,i), 0 )  .AND.                     &
+            .NOT. BTEST( wall_flags_0(k,j,i), 0   ) )                          & 
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 13 ) 
+!
+!--          Downward facing wall on u grid
+             IF ( BTEST( wall_flags_0(k-1,j,i), 1 )  .AND.                     &
+            .NOT. BTEST( wall_flags_0(k,j,i), 1   ) )                          & 
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 15 )
+!
+!--          Downward facing wall on v grid
+             IF ( BTEST( wall_flags_0(k-1,j,i), 2 )  .AND.                     &
+            .NOT. BTEST( wall_flags_0(k,j,i), 2   ) )                          & 
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 17 )
+!
+!--          Downward facing wall on w grid
+             IF ( BTEST( wall_flags_0(k-1,j,i), 3 )  .AND.                     &
+            .NOT. BTEST( wall_flags_0(k,j,i), 3 ) )                            & 
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 19 )
+          ENDDO
+!
+!--       Flags indicating upward facing walls
+          DO k = nzb, nzt
+!
+!--          Upward facing wall on scalar grid
+             IF ( .NOT. BTEST( wall_flags_0(k,j,i),   0 )  .AND.               &
+                        BTEST( wall_flags_0(k+1,j,i), 0 ) )                    & 
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 12 )
+!
+!--          Upward facing wall on u grid
+             IF ( .NOT. BTEST( wall_flags_0(k,j,i),   1 )  .AND.               &
+                        BTEST( wall_flags_0(k+1,j,i), 1 ) )                    & 
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 14 )
+
+!
+!--          Upward facing wall on v grid
+             IF ( .NOT. BTEST( wall_flags_0(k,j,i),   2 )  .AND.               &
+                        BTEST( wall_flags_0(k+1,j,i), 2 ) )                    & 
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 16 )
+
+!
+!--          Upward facing wall on w grid
+             IF ( .NOT. BTEST( wall_flags_0(k,j,i),   3 )  .AND.               &
+                        BTEST( wall_flags_0(k+1,j,i), 3 ) )                    & 
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 18 )
+!
+!--          Special flag on scalar grid, former nzb_s_inner
+             IF ( BTEST( wall_flags_0(k,j,i), 0 )  .OR.                        &
+                  BTEST( wall_flags_0(k,j,i), 12 ) .OR.                        &
+                  BTEST( wall_flags_0(k,j,i), 13 ) )                           &
+                wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 22 )
+!
+!--          Special flag on scalar grid, nzb_diff_s_inner - 1, required for 
+!--          flow_statistics
+             IF ( constant_flux_layer  .OR.  use_surface_fluxes )  THEN
+                IF ( BTEST( wall_flags_0(k,j,i),   0 )  .AND.                  &
+                     BTEST( wall_flags_0(k+1,j,i), 0 ) )                       &
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 23 )
+             ELSE
+                IF ( BTEST( wall_flags_0(k,j,i), 22 ) )                        &
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 23 )
+             ENDIF
+
+
+          ENDDO
+          wall_flags_0(nzt+1,j,i) = IBSET( wall_flags_0(nzt+1,j,i), 22 )
+          wall_flags_0(nzt+1,j,i) = IBSET( wall_flags_0(nzt+1,j,i), 23 )
+       ENDDO
+    ENDDO
+!
+!-- Exchange ghost points for wall flags
+    CALL exchange_horiz_int( wall_flags_0, nbgp )
+!
+!-- Set boundary conditions also for flags. Can be interpreted as Neumann
+!-- boundary conditions for topography. 
+    IF ( .NOT. bc_ns_cyc )  THEN
+       IF ( nys == 0  )  wall_flags_0(:,-1,:)   = wall_flags_0(:,0,:)
+       IF ( nyn == ny )  wall_flags_0(:,ny+1,:) = wall_flags_0(:,ny,:)
+    ENDIF
+    IF ( .NOT. bc_lr_cyc )  THEN
+       IF ( nxl == 0  )  wall_flags_0(:,:,-1)   = wall_flags_0(:,:,0)
+       IF ( nxr == nx )  wall_flags_0(:,:,nx+1) = wall_flags_0(:,:,nx)           
+    ENDIF
+
+!
+!-- Initialize boundary conditions via surface type
+    CALL init_bc
+!
+!-- Allocate and set topography height arrays required for data output
+    IF ( TRIM( topography ) /= 'flat' )  THEN
+!
+!--    Allocate and set the arrays containing the topography height
+
+       IF ( nxr == nx  .AND.  nyn /= ny )  THEN
+          ALLOCATE( zu_s_inner(nxl:nxr+1,nys:nyn),                             &
+                    zw_w_inner(nxl:nxr+1,nys:nyn) )
+       ELSEIF ( nxr /= nx  .AND.  nyn == ny )  THEN
+          ALLOCATE( zu_s_inner(nxl:nxr,nys:nyn+1),                             &
+                    zw_w_inner(nxl:nxr,nys:nyn+1) )
+       ELSEIF ( nxr == nx  .AND.  nyn == ny )  THEN
+          ALLOCATE( zu_s_inner(nxl:nxr+1,nys:nyn+1),                           &
+                    zw_w_inner(nxl:nxr+1,nys:nyn+1) )
+       ELSE
+          ALLOCATE( zu_s_inner(nxl:nxr,nys:nyn),                               &
+                    zw_w_inner(nxl:nxr,nys:nyn) )
+       ENDIF
+
+       zu_s_inner   = 0.0_wp
+       zw_w_inner   = 0.0_wp
+!
+!--    Determine local topography height on scalar and w-grid. Note, setting
+!--    lateral boundary values is not necessary, realized via wall_flags_0 
+!--    array. Further, please note that loop bounds are different from 
+!--    nxl to nxr and nys to nyn on south and right model boundary, hence, 
+!--    use intrinsic lbound and ubound functions to infer array bounds.
+       DO  i = lbound(zu_s_inner, 1), ubound(zu_s_inner, 1)
+          DO  j = lbound(zu_s_inner, 2), ubound(zu_s_inner, 2)
+!
+!--          Topography height on scalar grid. Therefore, determine index of 
+!--          upward-facing surface element on scalar grid (bit 12). 
+             zu_s_inner(i,j) = zu( MAXLOC( MERGE(                              &
+                                         1, 0, BTEST( wall_flags_0(:,j,i), 12 )&
+                                                ), DIM = 1                     &
+                                         ) - 1                                 &
+                                 )
+!
+!--          Topography height on w grid. Therefore, determine index of 
+!--          upward-facing surface element on w grid (bit 18).
+             zw_w_inner(i,j) = zw( MAXLOC( MERGE(                              &
+                                         1, 0, BTEST( wall_flags_0(:,j,i), 18 )&
+                                                ), DIM = 1                     &
+                                         ) - 1                                 &
+                                 )
+          ENDDO
+       ENDDO
+
+
+    ENDIF
+
 !
 !-- Calculate wall flag arrays for the multigrid method.
@@ -1450,8 +1875,8 @@
 !-- required in the ws-scheme, the arrays need to be allocated here as they are 
 !-- used in OpenACC directives. 
-    ALLOCATE( wall_flags_0(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                     &
-              wall_flags_00(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-    wall_flags_0  = 0
-    wall_flags_00 = 0
+    ALLOCATE( advc_flags_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                     &
+              advc_flags_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+    advc_flags_1 = 0
+    advc_flags_2 = 0
 !
 !-- Init flags for ws-scheme to degrade order of the numerics near walls, i.e. 
